import type { Coords, Diffable } from "../types";
type Badness = {
    history: string[];
    value: number;
};
type HeuristicsTarget<N extends string | number | symbol> = Coords & Diffable & {
    [K in N]: HeuristicsTarget<N> | null;
};
export declare function pickAlternative<K extends keyof T, T extends HeuristicsTarget<K>>(a: T, bItems: T[], debug?: boolean): [Item: T | undefined, Index: number, Badness: Badness];
type MultiAlternativeResult<T> = {
    matches: [T, T, Badness][];
    restA: T[];
    restB: T[];
};
export declare function matchUpAlternatives<K extends keyof T, T extends HeuristicsTarget<K>>(aItems: T[], bItems: T[]): MultiAlternativeResult<T>;
export {};
