import type { Input } from "@lezer/common";
import { ComposedRange, Coords } from "../../../types";
type Line = {
    line: number;
    from: number;
    to: number;
    sx: number;
    ex: number;
};
export type RangeEffect = {
    from: number;
    to: number;
    range: number;
};
export type ViewSegment = RangeEffect & {
    text: string;
};
export declare class Document implements Input {
    #private;
    lineChunks: boolean;
    constructor(code: string, from: number, to: number, ranges: ComposedRange[]);
    chunk(from: number): string;
    read(from: number, to: number): string;
    getLines(from: number, to: number): Line[];
    getRanges(): ComposedRange[];
    getLineByIdx(idx: number): Line;
    readSegments(from: number, to: number, holes: {
        from: number;
        to: number;
    }[]): ViewSegment[];
    measure(from: number, to: number): Coords;
    fromCoords(coords: Coords): {
        from: number;
        to: number;
    };
    get length(): number;
}
export {};
