import type { ADD, DEL, DiffOp, MOV, BAD, BDE, EQL, Diffable } from "../types";
export declare class Ops<T extends Diffable> {
    #private;
    getAll(): DiffOp<T>[];
    eqlItems(items: T[]): this;
    addItems(items: T[]): this;
    delItems(items: T[]): this;
    movItems({ from, to }: {
        from: T[];
        to: T[];
    }): void;
    static eql<T>(item: T): EQL<T>;
    static add<T>(item: T): ADD<T>;
    static del<T>(item: T): DEL<T>;
    static mov<T>(item: T, from: T): MOV<T>;
    static bad<T>(item: T): BAD<T>;
    static bde<T>(item: T, from: T): BDE<T>;
}
