import { CssRules } from "../lib/CSSRules";
import type { DecorationOutput, FrameMetadata, Language, Scene, Theme, UniqueDecoration } from "../types";
export type OutputContext = Readonly<{
    debug: boolean;
    rootClass: string;
    theme: Theme;
    class: (...longClasses: string[]) => string;
    var: {
        (longName: string, fallback?: any): string;
        raw(longName: string): string;
    };
    generateId: () => string;
    rules: CssRules;
}>;
export declare function getTokenType(inputType: string, language: Language): string;
export declare function createOutputContext(rootClass: string, theme: Theme, options: {
    debug: boolean;
}): OutputContext;
export declare function generateLineNrsHTML(rows: number, ctx: OutputContext): string;
export declare function toDecorationClassName(decoration: UniqueDecoration | DecorationOutput): string;
export declare function generateDecorationsHTML(decorations: Iterable<UniqueDecoration | DecorationOutput>, ctx: OutputContext): string;
export declare function generateDecorationsBaseCSS(decorations: Iterable<UniqueDecoration | DecorationOutput>, ctx: OutputContext): void;
export declare function addThemeVariables(content: FrameMetadata | Scene, ctx: OutputContext): void;
