import type { TextPosition, Coords, ExtendedDiffOp, ADD, BAD, MOV, BDE, EQL, Token, TokenOutput, DecorationPosition, Decoration, DecorationOutput } from "../types";
declare class ObjectPool<I extends Coords & {
    hash: number;
}, O extends {
    id: number;
}, P> {
    #private;
    constructor(toOutput: (item: I, newId: string) => O, toPosition: (opcode: "ADD" | "BAD" | "MOV" | "EQL" | "BDE", object: I) => P, keyGenerator: (item: I) => string);
    use(holder: Map<number, ExtendedDiffOp<I>>, operation?: ADD<I> | BAD<I> | MOV<I> | EQL<I> | BDE<I>): [O, P | undefined] | undefined;
    release(holder: Map<number, ExtendedDiffOp<I>>): undefined;
    renderObject(trace: Map<number, ExtendedDiffOp<I>>, frame: number): [O, P] | undefined;
    cleanup(): void;
    getEntries(): [number, O][];
}
export declare class TokenPool extends ObjectPool<Token, TokenOutput, TextPosition> {
    constructor();
}
export declare class DecorationPool extends ObjectPool<Decoration, DecorationOutput, DecorationPosition> {
    constructor();
}
export {};
