# Languages

The following languages are supported:

- **JavaScript** (identifier string: `"javascript"`)
- **TypeScript** (`"typescript"`)
- **HTML** (`"html"`, includes support for JavaScript inside `<script>` elements, CSS inside `<style>` elements, and JSON inside `<script type="importmap">` elements)
- **CSS** (`"css"`,)
- **JSON** (`"json"`)
- **Plain Text** (`"plaintext"`)

I you would like to see other languages supported, [head over to the CodeMovie meta repository on Github](https://github.com/CodeMovie/meta) and let me know.

## Metadata

Import `SUPPORTED_LANGUAGES` to access the list of supported languages' identifier strings:

```javascript
import { SUPPORTED_LANGUAGES } from "@codemovie/code-movie";
// Set of strings
```

TypeScript users can import the type `Language` to access a union of all language identifiers:

```typescript
import { type Language } from "@codemovie/code-movie";
// "css" | "javascript" | "plaintext" | "typescript" | "html" | "json"
```
